"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Record = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const view_1 = require("@codemirror/view");
const extensions_1 = require("@lqv/codemirror/extensions");
const recording_1 = require("@lqv/codemirror/recording");
const react_1 = require("@liqvid/keymap/react");
const react_2 = require("react");
const extensions_2 = require("../extensions.cjs");
const store_1 = require("../store.cjs");
const Editor_1 = require("./Editor.cjs");
/** Recording editor. */
const Record = (props) => {
    const { captureKeys = {
        "Mod-Enter": "run",
        "Mod-K": "clear",
        "Mod-L": "clear"
    }, extensions = [], group = "default", passKeys = ["Mod-Alt-2", "Mod-Alt-3", "Mod-Alt-4"], ...attrs } = props;
    const store = (0, store_1.useBoothStore)();
    const lqvKeymap = (0, react_1.useKeymap)();
    const newExtensions = (0, react_2.useMemo)(() => lqvKeymap ? [
        view_1.keymap.of((0, extensions_1.passThrough)(lqvKeymap, passKeys)),
        ...extensions
    ] : [], [passKeys]);
    // attach recording extensions --- this has to be done this way because
    // the `shortcuts` Compartment will abort further handling of the sequence
    (0, react_2.useEffect)(() => {
        const { view } = store.getState().groups[group].files.find(file => file.filename === props.filename);
        view.dispatch({
            effects: extensions_2.recording.reconfigure([
                extensions_2.recording.get(view.state),
                [recording_1.CodeRecording.recorder.extension(captureKeys)]
            ])
        });
    }, []);
    return ((0, jsx_runtime_1.jsx)(Editor_1.Editor, { content: props.content, extensions: newExtensions, ...attrs }));
};
exports.Record = Record;
