import { jsx as _jsx } from "react/jsx-runtime.js";
import { PlaybackContext, usePlayback } from "@lqv/playback/react";
import { useRef } from "react";
import { useStore } from "zustand";
import { BoothStore, makeStore } from "./store.mjs";
// buttons
export * from "./components/buttons.mjs";
export { Console } from "./components/Console.mjs";
export { Editor } from "./components/Editor.mjs";
export { EditorGroup } from "./components/EditorGroup.mjs";
export { EditorPanel } from "./components/EditorPanel.mjs";
export { FileTabs } from "./components/FileTabs.mjs";
export { Record } from "./components/Record.mjs";
export { Replay, ReplayMultiple } from "./components/Replay.mjs";
export { Resize } from "./components/Resize.mjs";
export * from "./extensions.mjs";
export { useBoothStore } from "./store.mjs";
/**
 * Container for code editing/recording/replaying.
 */
export const CodeBooth = (props) => {
    const { children, recorder, ...attrs } = props;
    const store = useRef();
    if (!store.current) {
        store.current = makeStore({ recorder });
    }
    const classNames = useStore(store.current, state => state.classNames);
    /* render */
    return (_jsx("div", { className: classNames.join(" "), "data-affords": "click", ...attrs, children: _jsx(BoothStore.Provider, { value: store.current, children: _jsx(PlaybackContext.Provider, { value: usePlayback(), children: props.children }) }) }));
};
